clear
eststo clear
use "$baseline_final/baseline_niger_outcomes.dta"

drop ///
cred_no_who__777 fert_where__777 prod_where__777 ctrans_whoelse__2 ctrans_whoelse__1 __UPDATED__ __FOOD_1__ __FOOD_2__ __NONFOOD__ __CELEBRATION__ __EDUCATION__ __HEALTH__ __EATOUT__ __TOTAL_CONSUMPTION_1__ __TOTAL_CONSUMPTION_2__

drop ///
_IDENTIFICATION_ _demog_ _BUSINESS_ _EMPLOYMENT_ _CONSUMPTION_ _ASSETS_ _LIVESTOCK_ _AGRICULTURE_ _FINANCE_ _PSYCHOLOGY_ _FOODSEC_ _TRANSFERS_ _social_ _loans_ _lab_prtcp_

drop ///
_mdemog _mSec _mbusnum _mBus2 _mBus_B81_84 _mBus_invest _mBus_estim _mBus_workers _madult _mNONAG2 _mACTIV _mfoodMeth2 _mnonfood _mceleb _meduc _mhealth _meatout _mCONSUM _mfu_b51 _mfu_b52 _mASSETS _mCounts _mDiv _mown _mRev _mLIV _mAGRIC _mFIN _mPSYC _mFSEC _m_transin _mTRF _msocial_c2 _mloans_c2 _mben_lab1 _mben_lab2 _mben_lab3 _mben_lab4 _mben_lab6 _mLab


drop list_*
drop hhidbis

drop ///
cred_o cred_no_o cred_no_why_o hou_type_o hou_wall_o hou_root_o hou_floor_o hou_toilet_o pref_prog_why_o fert_where_o prod_where_o prog_o shock_o choc_strategy18_o

drop ///
random_num random_baby_posinlist random_baby_pos random_baby_mom_pos random_baby_carer_pos

drop ///
hh_currentlist baby_pos_list shock_list strat_list

drop ///
*whoelse*

drop chef_pos
drop today submissiondate

drop ///
plot_name1 plot_name2 plot_name3 plot_name4 plot_name5 plot_name6 plot_name7 plot_name8 plot_name9 plot_name10 plot_name11 plot_name12 plot_name13 plot_name14 plot_name15 plot_name16 plot_name17 plot_name18

drop ///
who_fourleg who_twoleg

drop country
drop commune_
drop department_
drop codevillage

drop ///
fu_hh_status status_explain cred_no_who ment_who_present fert_where prod_where fish_who strat_best1_o strat_best2_o instance ccode pap_b3_5 pap_b2_2 pap_d5 pap_b3 pap_b10_3_4 pap_b2_b1035

quietly destring, replace

des, short

quietly compress


//     ds *, not(type string)
//     local nostrings = r(varlist)
//
//     {
//     * recode numeric to missing
//     mvdecode `nostrings', mv(-999 = .r) // refused
//     mvdecode `nostrings', mv(-888 = .d) // don't know
//     mvdecode `nostrings', mv(-777 = .o) // other
//     mvdecode `nostrings', mv(-666 = .n) // na 
//     mvdecode `nostrings', mv(-555 = .g) // god or unknown relation
//     mvdecode `nostrings', mv(-333 = .m) 
//     mvdecode `nostrings', mv(-222 = .r)
//     mvdecode `nostrings', mv(-111 = .i)
//     mvdecode `nostrings', mv(-99 = .i)
//     mvdecode `nostrings', mv(-88 = .i)
//     mvdecode `nostrings', mv(-77 = .i)
//     mvdecode `nostrings', mv(-66 = .i)
//     }


* these variables are constant or missing


foreach var of varlist _all {
    capture assert missing(`var')
    if !_rc {
        drop `var'
    }
}

#delimit ;
drop
region_ consent count_chefs sav_loc_1 sav_loc_0 save_loc8 save_loc9 save_loc10
                gp_savemoreinfo_count cred_no_who_6 r_four_count prog_7 calc_shock1 calc_shock2 calc_shock3
                calc_shock4 calc_shock5 calc_shock6 calc_shock7 calc_shock8 calc_shock9 calc_shock10
                calc_shock11 calc_shock12 calc_shock13 div_ani_o ag_c2_harvest_imp_xof ag_c3_harvest_imp_xof
                ag_c4_harvest_imp_xof ag_c5_harvest_imp_xof ag_c6_harvest_imp_xof ag_c7_harvest_imp_xof
                ag_c9_harvest_imp_xof ag_c11_harvest_imp_xof ag_c19_harvest_imp_xof ag_c21_harvest_imp_xof
                ag_c23_harvest_imp_xof ag_c26_harvest_imp_xof ag_c31_harvest_imp_xof ag_c34_harvest_imp_xof
                ag_c38_harvest_imp_xof ag_c40_harvest_imp_xof ag_c42_harvest_imp_xof ag_c47_harvest_imp_xof
                ag_r_c11_d ag_r_c15_d ag_r_c19_d ag_r_c2_d ag_r_c21_d ag_r_c23_d ag_r_c24_d ag_r_c26_d ag_r_c3_d
                ag_r_c33_d ag_r_c4_d ag_r_c40_d ag_r_c42_d ag_r_c5_d ag_r_c6_d ag_r_c7_d ag_r_c9_d ag_d_c1_d
                ag_d_c10_d ag_d_c11_d ag_d_c12_d ag_d_c2_d ag_d_c26_d ag_d_c3_d ag_d_c31_d ag_d_c34_d ag_d_c37_d
                ag_d_c38_d ag_d_c42_d ag_d_c47_d ag_d_c8_d ag_d_cterre_d ;

#delimit cr

drop ///
cred_no_who_1 cred_no_who_2 cred_no_who_3 cred_no_who_4 cred_no_who_5 ment_who_present_0 ment_who_present_1 ment_who_present_2 ment_who_present_3 ment_who_present_4 ment_who_present_5

drop cred_no_why pref_prog_why
des, short

foreach var of varlist _all {
    capture assert missing(`var')
    if !_rc {
        drop `var'
    }
}


des, short

drop ag_r_harvest_xof_imp_95 ag_r_harvest_xof_imp_98 ag_r_harvest_xof_imp_99 ag_r_harvest_chef_xof_imp_98 ag_r_harvest_1_imp_xof ag_r_harvest_2_imp_xof ag_r_harvest_3_imp_xof ag_r_harvest_4_imp_xof ag_r_harvest_5_imp_xof ag_r_harvest_6_imp_xof ag_r_harvest_7_imp_xof


drop ag_c1_harvest_imp_xof ag_c8_harvest_imp_xof ag_c10_harvest_imp_xof ag_c12_harvest_imp_xof ag_c13_harvest_imp_xof ag_c14_harvest_imp_xof ag_c15_harvest_imp_xof ag_c16_harvest_imp_xof ag_c17_harvest_imp_xof ag_c24_harvest_imp_xof ag_c25_harvest_imp_xof ag_c27_harvest_imp_xof ag_c28_harvest_imp_xof ag_c29_harvest_imp_xof ag_c30_harvest_imp_xof ag_c32_harvest_imp_xof ag_c33_harvest_imp_xof ag_c35_harvest_imp_xof ag_c37_harvest_imp_xof ag_c46_harvest_imp_xof ag_cother_harvest_imp_xof

drop ag_r_sale_imp_xof_95 ag_r_sale_imp_xof_98 ag_r_sale_imp_xof_99 ag_d_harvest_xof_imp_95 ag_d_harvest_xof_imp_98 ag_d_harvest_xof_imp_99 ag_d_harvest_chef_xof_imp_98 ag_d_harvest_1_imp_xof ag_d_harvest_2_imp_xof ag_d_harvest_3_imp_xof ag_d_harvest_4_imp_xof ag_d_harvest_5_imp_xof ag_d_harvest_6_imp_xof ag_d_harvest_7_imp_xof ag_d_sale_imp_xof_95 ag_d_sale_imp_xof_98 ag_d_sale_imp_xof_99 ag_harvest_12_xof_imp_95 ag_harvest_12_xof_imp_98 ag_harvest_12_xof_imp_99 ag_sale_xof_imp_95 ag_sale_xof_imp_98 ag_sale_xof_imp_99

drop ag_harvest_12_xof_imp ag_harvest_12_chef_xof_imp ag_harvest_12_hhlb_xof_imp ag_harvest_12_bohh_xof_imp ag_sale_xof_imp

* every observation has at least some missing in some variables, so need to trim dataset further

// drop ag_r_harvest_1_imp_xof ag_r_harvest_2_imp_xof ag_r_harvest_3_imp_xof ag_r_harvest_4_imp_xof ag_r_harvest_5_imp_xof ag_r_harvest_6_imp_xof ag_r_harvest_7_imp_xof ag_r_sale_imp_xof ag_c1_harvest_imp_xof ag_c8_harvest_imp_xof ag_c10_harvest_imp_xof ag_c12_harvest_imp_xof ag_c13_harvest_imp_xof ag_c14_harvest_imp_xof ag_c15_harvest_imp_xof ag_c16_harvest_imp_xof ag_c17_harvest_imp_xof ag_c24_harvest_imp_xof ag_c25_harvest_imp_xof ag_c27_harvest_imp_xof ag_c28_harvest_imp_xof ag_c29_harvest_imp_xof ag_c30_harvest_imp_xof ag_c32_harvest_imp_xof ag_c33_harvest_imp_xof ag_c35_harvest_imp_xof ag_c37_harvest_imp_xof ag_c46_harvest_imp_xof ag_cother_harvest_imp_xof ag_r_sale_imp_xof_95 ag_r_sale_imp_xof_98 ag_r_sale_imp_xof_99 ag_d_harvest_1_imp_xof ag_d_harvest_2_imp_xof ag_d_harvest_3_imp_xof ag_d_harvest_4_imp_xof ag_d_harvest_5_imp_xof ag_d_harvest_6_imp_xof ag_d_harvest_7_imp_xof ag_d_sale_imp_xof ag_d_sale_imp_xof_95 ag_d_sale_imp_xof_98 ag_d_sale_imp_xof_99 ag_harvest_12_xof_imp ag_harvest_12_xof_imp_95 ag_harvest_12_xof_imp_98 ag_harvest_12_xof_imp_99 ag_harvest_12_chef_xof_imp ag_harvest_12_hhlb_xof_imp ag_harvest_12_bohh_xof_imp ag_sale_xof_imp ag_sale_xof_imp_95 ag_sale_xof_imp_98 ag_sale_xof_imp_99

foreach var in shock1b shock2b shock3b shock4b shock5b shock6b shock7b shock8b shock9b shock10b shock11b shock12b choc_strategy1 choc_strategy2 choc_strategy3 choc_strategy4 choc_strategy5 choc_strategy6 choc_strategy7 choc_strategy8 choc_strategy9 choc_strategy10 choc_strategy11 choc_strategy12 choc_strategy13 choc_strategy14 choc_strategy15 choc_strategy16 choc_strategy17 choc_strategy18 choc_strategy1u choc_strategy2u choc_strategy3u choc_strategy4u choc_strategy5u choc_strategy6u choc_strategy7u choc_strategy8u choc_strategy9u choc_strategy10u choc_strategy11u choc_strategy12u choc_strategy13u choc_strategy14u choc_strategy15u choc_strategy16u choc_strategy18u {
    replace `var' = 0 if missing(`var')
}

// drop choc_strategy1u choc_strategy2u choc_strategy3u choc_strategy4u choc_strategy5u choc_strategy6u choc_strategy7u choc_strategy8u choc_strategy9u choc_strategy10u choc_strategy11u choc_strategy12u choc_strategy13u choc_strategy14u choc_strategy15u choc_strategy16u choc_strategy18u

// drop *_imp_*

drop div_cereal_child div_pulse_child div_milk_child div_meat_child div_egg_child div_fruit_vita_child div_fruit_child
drop div_cereal_mom div_pulse_mom div_pulse2_mom div_milk_mom div_meat_mom div_egg_mom div_veg_mom div_fruit1_mom div_veg_vita_mom div_fruit_mom

// drop food_1_day_xof food_1_year_xof food_1_day_pc_xof food_1_day_eq_xof food_2_week_xof food_2_day_xof food_2_year_xof food_2_day_pc_xof food_2_day_eq_xof

/*
foreach var of varlist _all {
    replace `var' = 1 if !missing(`var')
    replace `var' = 0 if `var' != 1
}

collapse (mean) *

rename * stub_*

gen id = 1
order id, first
reshape long stub, i(id) j(j)
*/

des, short

* dropping variables with more than 1% missing, modify if imputing values etc

foreach var of varlist * {    
    qui count if missing(`var')      
    if (r(N)/_N) >= 0.01 drop `var'    
}

des, short

vl set, dummy


/*
local primary_panel fcs tmpvar
local mentalhealth_panel cantril mentalhealth 
local loans_panel loans_twelve_mo loans_amt 
local savings_panel saved_binary saved_total
*/

vl move (fcs food_1_week_xof cantril mentalhealth loan_d aloan_xof saved_bank saving_xof) vlother
vl move (hhid) vlother
vl move (village) vlcategorical

vl move (fu_hhsize_load fu_chef_age hh_size_actual ask_siblings ask_otherfam ask_friends ask_otherknown) vlcategorical

vl move ///
(hhh_age hhh_edu mem_n adult_n workage_n child_n earlychild_n olderchild_n ///
bus_pro12_chef_1 bus_pro12_chef_2 bus_pro12_chef_3 bus_pro12_chef_5 bus_pro12_chef_6 bus_pro12_chef_7 ///
bus_pro12_hh_1 bus_pro12_hh_2 bus_pro12_hh_3 bus_pro12_hh_5 bus_pro12_hh_6 bus_pro12_hh_7 ///
bus_rev12_chef_1 bus_rev12_chef_2 bus_rev12_chef_3 bus_rev12_chef_6 bus_rev12_chef_7 bus_rev12_chef_9 ///
bus_rev12_hh_1 bus_rev12_hh_2 bus_rev12_hh_3 bus_rev12_hh_5 bus_rev12_hh_6 bus_rev12_hh_7 ///
tot_busmths_uniq tot_busmths_uniq_chef hh_ass_count_hh_95 hh_ass_count_hh_98 hh_ass_count_ovr_98 hh_ass_count_chef_95 hh_ass_count_chef_98 hh_ass_count_hhlb_95 hh_ass_count_hhlb_98 tot_ani_count tot_ani_count_tlu tot_ani_count_tlu_chef tot_ani_count_tlu_hhlb liv_bov liv_cap liv_ov liv_vol ag_plot_n ag_r_sale_xof div_ag_n ag_r_fert_xof ag_r_pest_xof ag_r_paidlab_xof saving_xof saving_inf_xof aut_fond_ppp_w aut_fond_xof_w hh_wrk_ag_num12 ///
aut_fond aut_volu) vlcontinuous

vl move (fu_hhsize_load fu_chef_age new_mem_n hh_size_actual under_24_count) vlcontinuous
vl move (div_cereal div_pulse div_milk div_meat div_meat2 div_meat_org div_fish div_egg div_veg div_veg_vita div_vega div_fruit div_fruit_vita div_oil div_sugar div_spice los1 cd1 cd2 cd3_new cd4 cd5 cd6_new cd7 cd8 cd9 cd10_new useless soc_post business_num hh_act_n div_ani ani12_1 ani12_2 ani12_3 ani12_4 ani12_5 ani12_6 ani12_7 ani12_8 ani12_9 ani12_10 ani12_11 ag_r_plot_cult_n ag_d_plot_cult_n div_rain_n div_dry_n div_crop_types saving_for_xof) vlcontinuous

vl move (shock_n elder_n hh_ass_count_tv_98 liv_ane liv_cham liv_chev) vlcontinuous

des, short 
vl rebuild

foreach var in $vlcontinuous {
    quietly gen sqd_`var' = `var'^2
}

vl rebuild
des, short
vl clear
vl set, dummy

vl move (fcs food_1_week_xof cantril mentalhealth loan_d aloan_xof saved_bank saving_xof) vlother
vl move (hhid) vlother
vl move (village) vlcategorical

vl move (fu_hhsize_load fu_chef_age hh_size_actual ask_siblings ask_otherfam ask_friends ask_otherknown) vlcategorical

vl move ///
(hhh_age hhh_edu mem_n adult_n workage_n child_n earlychild_n olderchild_n ///
bus_pro12_chef_1 bus_pro12_chef_2 bus_pro12_chef_3 bus_pro12_chef_5 bus_pro12_chef_6 bus_pro12_chef_7 ///
bus_pro12_hh_1 bus_pro12_hh_2 bus_pro12_hh_3 bus_pro12_hh_5 bus_pro12_hh_6 bus_pro12_hh_7 ///
bus_rev12_chef_1 bus_rev12_chef_2 bus_rev12_chef_3 bus_rev12_chef_6 bus_rev12_chef_7 bus_rev12_chef_9 ///
bus_rev12_hh_1 bus_rev12_hh_2 bus_rev12_hh_3 bus_rev12_hh_5 bus_rev12_hh_6 bus_rev12_hh_7 ///
tot_busmths_uniq tot_busmths_uniq_chef hh_ass_count_hh_95 hh_ass_count_hh_98 hh_ass_count_ovr_98 hh_ass_count_chef_95 hh_ass_count_chef_98 hh_ass_count_hhlb_95 hh_ass_count_hhlb_98 tot_ani_count tot_ani_count_tlu tot_ani_count_tlu_chef tot_ani_count_tlu_hhlb liv_bov liv_cap liv_ov liv_vol ag_plot_n ag_r_sale_xof div_ag_n ag_r_fert_xof ag_r_pest_xof ag_r_paidlab_xof saving_xof saving_inf_xof aut_fond_ppp_w aut_fond_xof_w hh_wrk_ag_num12 ///
aut_fond aut_volu) vlcontinuous

vl move (fu_hhsize_load fu_chef_age new_mem_n hh_size_actual under_24_count) vlcontinuous
vl move (div_cereal div_pulse div_milk div_meat div_meat2 div_meat_org div_fish div_egg div_veg div_veg_vita div_vega div_fruit div_fruit_vita div_oil div_sugar div_spice los1 cd1 cd2 cd3_new cd4 cd5 cd6_new cd7 cd8 cd9 cd10_new useless soc_post business_num hh_act_n div_ani ani12_1 ani12_2 ani12_3 ani12_4 ani12_5 ani12_6 ani12_7 ani12_8 ani12_9 ani12_10 ani12_11 ag_r_plot_cult_n ag_d_plot_cult_n div_rain_n div_dry_n div_crop_types saving_for_xof) vlcontinuous

vl move (shock_n elder_n hh_ass_count_tv_98 liv_ane liv_cham liv_chev) vlcontinuous

vl move (sqd_*) vlcontinuous

des, short 
vl rebuild

vl create idummy = vldummy
vl create icategorical = vlcategorical
vl create icontinuous = vlcontinuous
vl create iuncertain = vluncertain
vl create iother = vlother

vl rebuild

// vl move (los1 cd1 cd2 cd3_new cd4 cd5 cd6_new cd7 cd8 cd9 cd10_new useless) 
// vl move (stair_status_today stair_status_future cantril stair_satis_future stair_good_today stair_respect_new stair_opinion_new) 

set seed 3591

dsregress fcs i.treatment, controls(${idummy} ${icategorical} ${icontinuous} food_1_week_xof cantril mentalhealth loan_d aloan_xof saved_bank saving_xof) selection(cv)
global blk1 = e(controls_sel)
dsregress food_1_week_xof i.treatment, controls(${idummy} ${icategorical} ${icontinuous} fcs cantril mentalhealth loan_d aloan_xof saved_bank saving_xof) selection(cv)
global blk2 = e(controls_sel)
dsregress cantril i.treatment, controls(${idummy} ${icategorical} ${icontinuous} fcs food_1_week_xof mentalhealth loan_d aloan_xof saved_bank saving_xof) selection(cv)
global blk3 = e(controls_sel)
dsregress mentalhealth i.treatment, controls(${idummy} ${icategorical} ${icontinuous} fcs food_1_week_xof cantril loan_d aloan_xof saved_bank saving_xof) selection(cv)
global blk4 = e(controls_sel)

global merged : list global(blk1) | global(blk2)
global merged : list global(merged) | global(blk3)
global merged : list global(merged) | global(blk4)

local nvars : list sizeof global(merged)
di "`nvars'"

keep hhid $merged

rename * bl_*
rename bl_hhid hhid
save "$baseline_final/dslasso-selected-vars.dta", replace