** de-identify

local path = "/Users/rongmondeka/Desktop/long"
local myfiles: dir "`path'" files "*.dta"

di `myfiles'

foreach file in `myfiles' {
    di as error "`file'"
    use "`path'/`file'", clear
    
    des, short
    
    local idvars ///
    resp_name resp_confirm resp_name_pull *fullname* *firstname* *lastname* ///
    gps* ///
    address* *address* *key_name* ///
    fname lname current_name ///
    setof*
    
    foreach var in `idvars' {
        capture ds `var'
        capture drop `r(varlist)'
    }
    
    des, short
    
    quietly destring *, replace
    
    notes drop *
    
    if "`file'" == "niger 2023- shock response- endline.dta" {
        drop start_*
        drop starttime

        drop end_*
        drop endtime

        drop deviceid subscriberid simid devicephonenum
        drop allows_comments records_time instancename
        drop isvalidated
        drop resp_consum*
        drop note_*

        label variable hhid "Household ID"
    }
    
    save "${raw}/`file'", replace

}

